# EXERCISE 1: Improvement of the agitr_chapter3 package

This package contains:

- The program **pubvel.cpp**, whose executable file called *pubvel* creates a node called *publish_velocity*. This node broadcasts random command velocities to be used by the turtlesim node to move a turtle.

- The program **subpose.cpp**, whose executable file called *subpose* creates a node called *subscribe_to_pose*. This node subscribes to the pose messages send by the turtle of the turtlesim package, and prints it in the terminal.

- The program **pubvelsafe.cpp**, whose executable file called *pubvelsafe* creates a node called *publish_safe_velocity*. This node broadcasts random command velocities to be used by the turtlesim node to move a turtle with the following feature:

 1. Sends a random angular velocity command and a fixed linear velocity of 1.0 when the turtle is placed in a safe zone defined by a square around the center of the window.

 2. Sends a random angular velocity and a random linear velocity (i.e. as done in pubvel.cpp) otherwise.


- The program **pubvelsafe_b.cpp**, whose executable file called *pubvelsafe_b* creates a node called *publish_safe_velocity_b* that behavies as node *publish_safe_velocity_b* but adds the following feature:

 3. Adds a turn motion (i.e. msg.angular.z = - M_PI) when the turtle isnext to the wall.
